"""Autogenerated API schema"""
from argus_api import session


add_asset_vulnerability = {'tags': ['assets/v1'], 'summary': 'Creates a new AssetVulnerability. (PUBLIC)', 'description': '', 'operationId': 'addAssetVulnerability', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'AssetVulnerability add request', 'required': False, 'schema': {'type': 'object', 'required': ['hostID', 'source', 'vulnerabilityID'], 'properties': {'hostID': {'type': 'str', 'position': 0, 'description': 'Specify parent host. '}, 'vulnerabilityID': {'type': 'str', 'position': 0, 'description': 'Identifier of vulnerability (e.g. plug-in ID from vulnerability scanner).  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'references': {'type': 'list', 'position': 0, 'description': 'References to vulnerability (e.g. CVE number). ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of vulnerability. Will be sanitized and no line break allowed. ', 'minLength': 0, 'maxLength': 255}, 'description': {'type': 'str', 'position': 0, 'description': 'Description of vulnerability. Will be sanitized. '}, 'conclusion': {'type': 'str', 'position': 0, 'description': 'Short summary of vulnerability. Will be sanitized. '}, 'solution': {'type': 'str', 'position': 0, 'description': 'How to fix vulnerability. Will be sanitized. '}, 'rawOutput': {'type': 'str', 'position': 0, 'description': 'Raw output from vulnerability scan. Will be sanitized. '}, 'cvss': {'type': 'float', 'position': 0, 'description': 'CVSS score of vulnerability (range from 0 to 10). ', 'minimum': 0, 'maximum': 10}, 'severity': {'type': 'str', 'position': 0, 'description': 'Severity level of vulnerability. ', 'enum': ['INFO', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'info', 'low', 'medium', 'high', 'critical']}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Custom user-defined properties.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}, 'exploitAvailable': {'type': 'bool', 'position': 0, 'description': 'Set if an exploit is available for the vulnerability. '}, 'source': {'type': 'str', 'position': 0, 'description': 'Source of the request. (default USER)', 'enum': ['USER', 'CVM']}, 'socket': {'type': 'str', 'position': 0, 'description': 'Specify socket string of the vulnerability (e.g. tcp/80), or omit if not bound to a socket. '}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
delete_asset_vulnerability = {'tags': ['assets/v1'], 'summary': 'Marks an AssetVulnerability as deleted. (PUBLIC)', 'description': '', 'operationId': 'deleteAssetVulnerability', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'AssetVulnerability ID', 'required': True, 'type': 'str'}, {'name': 'source', 'in': 'query', 'description': 'Request source (default USER)', 'required': False, 'type': 'str', 'default': 'USER', 'enum': ['USER', 'CVM']}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
get_asset_vulnerability = {'tags': ['assets/v1'], 'summary': 'Returns an AssetVulnerability identified by its ID. (PUBLIC)', 'description': '', 'operationId': 'getAssetVulnerability', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'AssetVulnerability ID', 'required': True, 'type': 'str'}, {'name': 'includeRawOutput', 'in': 'query', 'description': 'Include raw output', 'required': False, 'type': 'bool', 'default': False}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
reopen_asset_vulnerability = {'tags': ['assets/v1'], 'summary': 'Reopen a resolved AssetVulnerability. (PUBLIC)', 'description': 'Cannot reopen an unresolved AssetVulnerability. Reopen will update AssetVulnerability to reset resolution to be unresolved, remove resolution comment, resolution timestamp and resolved by user.', 'operationId': 'reopenAssetVulnerability', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'AssetVulnerability ID', 'required': True, 'type': 'str'}, {'in': 'body', 'name': 'body', 'description': 'AssetVulnerability reopen request', 'required': False, 'schema': {'type': 'object', 'required': ['source'], 'properties': {'source': {'type': 'str', 'position': 0, 'description': 'Source of the request. (default USER)', 'enum': ['USER', 'CVM']}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
resolve_asset_vulnerability = {'tags': ['assets/v1'], 'summary': 'Resolves an AssetVulnerability. (PUBLIC)', 'description': '', 'operationId': 'resolveAssetVulnerability', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'AssetVulnerability ID', 'required': True, 'type': 'str'}, {'in': 'body', 'name': 'body', 'description': 'AssetVulnerability resolve request', 'required': False, 'schema': {'type': 'object', 'required': ['comment', 'resolution', 'source'], 'properties': {'resolution': {'type': 'str', 'position': 0, 'description': 'Specify resolution reason. ', 'enum': ['ACCEPTED', 'TEMPORARILY_ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE']}, 'resolutionExpiryTimestamp': {'type': 'int', 'position': 0, 'description': 'When will the current resolution expire (0 means no expiry). Allows unix timestamp (milliseconds), ISO timestamp, or relative time values. See https://docs.mnemonic.no/x/AQDXAQ (default 0)', 'minimum': 0, 'default': 0}, 'comment': {'type': 'str', 'position': 0, 'description': 'Comment on why the vulnerability is resolved.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'source': {'type': 'str', 'position': 0, 'description': 'Source of the request. (default USER)', 'enum': ['USER', 'CVM']}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
search_asset_vulnerabilities = {'tags': ['assets/v1'], 'summary': 'Returns a set of AssetVulnerabilities defined by an AssetVulnerabilitySearchCriteria. (PUBLIC)', 'description': '', 'operationId': 'searchAssetVulnerabilities', 'consumes': ['application/json'], 'produces': ['application/json', 'text/csv'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Search criteria', 'required': False, 'schema': {'type': 'object', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'startTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Set this value to set max number of results. By default, no restriction on result set size. '}, 'offset': {'type': 'int', 'position': 0, 'description': 'Set this value to skip the first (offset) objects. By default, return result from first object. '}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects. '}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR. ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'startTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Set this value to set max number of results. By default, no restriction on result set size. '}, 'offset': {'type': 'int', 'position': 0, 'description': 'Set this value to skip the first (offset) objects. By default, return result from first object. '}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects. '}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR. ', 'uniqueItems': True, 'items': []}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded. '}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria). '}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers. ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'minimumCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to vulnerabilities with CVSS score at least this high. ', 'minimum': 0, 'maximum': 10}, 'maximumCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to vulnerabilities with CVSS score no more than this. ', 'minimum': 0, 'maximum': 10}, 'severity': {'type': 'list', 'position': 0, 'description': 'Restrict search to specified severity levels. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['INFO', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'info', 'low', 'medium', 'high', 'critical']}}, 'resolutionCode': {'type': 'list', 'position': 0, 'description': 'Restrict search to specific resolution codes. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['UNRESOLVED', 'ACCEPTED', 'TEMPORARILY_ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE']}}, 'vulnerabilityReference': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability reference. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'vulnerabilityID': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability ID. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'resolutionTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['vulnerabilityID', 'references', 'name', 'description', 'conclusion', 'solution', 'rawOutput', 'hostName', 'hostAlias', 'all']}}, 'includeRawOutput': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability rawOutput in result (default false) '}, 'includeConclusion': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability conclusion in result (default false) '}, 'includeSolution': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability solution in result (default false) '}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending). ', 'items': {'type': 'str', 'enum': ['vulnerabilityID', 'socket', 'name', 'cvss', 'severity', 'resolution', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'resolutionTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded. '}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria). '}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers. ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'minimumCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to vulnerabilities with CVSS score at least this high. ', 'minimum': 0, 'maximum': 10}, 'maximumCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to vulnerabilities with CVSS score no more than this. ', 'minimum': 0, 'maximum': 10}, 'severity': {'type': 'list', 'position': 0, 'description': 'Restrict search to specified severity levels. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['INFO', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'info', 'low', 'medium', 'high', 'critical']}}, 'resolutionCode': {'type': 'list', 'position': 0, 'description': 'Restrict search to specific resolution codes. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['UNRESOLVED', 'ACCEPTED', 'TEMPORARILY_ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE']}}, 'vulnerabilityReference': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability reference. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'vulnerabilityID': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability ID. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'resolutionTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['vulnerabilityID', 'references', 'name', 'description', 'conclusion', 'solution', 'rawOutput', 'hostName', 'hostAlias', 'all']}}, 'includeRawOutput': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability rawOutput in result (default false) '}, 'includeConclusion': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability conclusion in result (default false) '}, 'includeSolution': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability solution in result (default false) '}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending). ', 'items': {'type': 'str', 'enum': ['vulnerabilityID', 'socket', 'name', 'cvss', 'severity', 'resolution', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'resolutionTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
search_asset_vulnerabilities_simplified = {'tags': ['assets/v1'], 'summary': 'Returns as set of AssetVulnerabilities defined by query parameters. (PUBLIC)', 'description': '', 'operationId': 'searchAssetVulnerabilitiesSimplified', 'produces': ['application/json', 'text/csv'], 'parameters': [{'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'required': False, 'type': 'int', 'default': 0, 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'required': False, 'type': 'int', 'default': 25, 'minimum': 0}, {'name': 'keywords', 'in': 'query', 'description': 'Search by keywords', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'keywordMatch', 'in': 'query', 'description': 'Set match strategy for keyword search', 'required': False, 'type': 'str', 'default': 'all', 'enum': ['all', 'any']}, {'name': 'keywordField', 'in': 'query', 'description': 'Set field strategy for keyword search', 'required': False, 'type': 'list', 'items': {'type': 'str', 'default': 'all', 'enum': ['vulnerabilityID', 'references', 'name', 'description', 'conclusion', 'solution', 'rawOutput', 'hostName', 'hostAlias', 'all']}, 'collectionFormat': 'multi'}, {'name': 'name', 'in': 'query', 'description': 'Search by name', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'hostID', 'in': 'query', 'description': 'Search by HostAsset ID', 'required': False, 'type': 'list', 'items': {'type': 'str'}, 'collectionFormat': 'multi'}, {'name': 'serviceID', 'in': 'query', 'description': 'Search by ServiceAsset ID', 'required': False, 'type': 'list', 'items': {'type': 'str'}, 'collectionFormat': 'multi'}, {'name': 'businessProcessID', 'in': 'query', 'description': 'Search by BusinessProcess ID', 'required': False, 'type': 'list', 'items': {'type': 'str'}, 'collectionFormat': 'multi'}, {'name': 'customerID', 'in': 'query', 'description': 'Search by customer ID', 'required': False, 'type': 'list', 'items': {'type': 'int'}, 'collectionFormat': 'multi'}, {'name': 'ip', 'in': 'query', 'description': 'Search by IP range', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'port', 'in': 'query', 'description': 'Search by application port', 'required': False, 'type': 'list', 'items': {'type': 'int'}, 'collectionFormat': 'multi'}, {'name': 'protocol', 'in': 'query', 'description': 'Search by application protocol', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}, 'collectionFormat': 'multi'}, {'name': 'cpe', 'in': 'query', 'description': 'Search by CPE', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'vulnID', 'in': 'query', 'description': 'Search by vulnerability ID', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'vulnRef', 'in': 'query', 'description': 'Search by vulnerability reference', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'resolutionCode', 'in': 'query', 'description': 'Search by resolution code', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['UNRESOLVED', 'ACCEPTED', 'TEMPORARILY_ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE']}, 'collectionFormat': 'multi'}, {'name': 'severity', 'in': 'query', 'description': 'Search by Vulnerability Severity', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['INFO', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'info', 'low', 'medium', 'high', 'critical']}, 'collectionFormat': 'multi'}, {'name': 'includeFlag', 'in': 'query', 'description': 'Include certain BusinessProcesses in the search result based on set flags', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}, 'collectionFormat': 'multi'}, {'name': 'excludeFlag', 'in': 'query', 'description': 'Exclude certain BusinessProcesses from the search result based on set flags', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}, 'collectionFormat': 'multi'}, {'name': 'sortBy', 'in': 'query', 'description': 'Sort search result', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'countTimeout', 'in': 'query', 'description': 'Max wait in seconds for count query. Value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'required': False, 'type': 'int', 'maximum': 30, 'minimum': -1}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
search_asset_vulnerability_statistics = {'tags': ['assets/v1'], 'summary': 'Fetch asset vulnerability statistics base on criteria (PUBLIC)', 'description': '', 'operationId': 'searchAssetVulnerabilityStatistics', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Statistics search criteria', 'required': False, 'schema': {'type': 'object', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'startTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Set this value to set max number of results. By default, no restriction on result set size. '}, 'offset': {'type': 'int', 'position': 0, 'description': 'Set this value to skip the first (offset) objects. By default, return result from first object. '}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects. '}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR. ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'startTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Set this value to set max number of results. By default, no restriction on result set size. '}, 'offset': {'type': 'int', 'position': 0, 'description': 'Set this value to skip the first (offset) objects. By default, return result from first object. '}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects. '}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR. ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'startTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Set this value to set max number of results. By default, no restriction on result set size. '}, 'offset': {'type': 'int', 'position': 0, 'description': 'Set this value to skip the first (offset) objects. By default, return result from first object. '}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects. '}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR. ', 'uniqueItems': True, 'items': []}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded. '}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria). '}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers. ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'minimumCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to vulnerabilities with CVSS score at least this high. ', 'minimum': 0, 'maximum': 10}, 'maximumCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to vulnerabilities with CVSS score no more than this. ', 'minimum': 0, 'maximum': 10}, 'severity': {'type': 'list', 'position': 0, 'description': 'Restrict search to specified severity levels. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['INFO', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'info', 'low', 'medium', 'high', 'critical']}}, 'resolutionCode': {'type': 'list', 'position': 0, 'description': 'Restrict search to specific resolution codes. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['UNRESOLVED', 'ACCEPTED', 'TEMPORARILY_ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE']}}, 'vulnerabilityReference': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability reference. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'vulnerabilityID': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability ID. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'resolutionTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['vulnerabilityID', 'references', 'name', 'description', 'conclusion', 'solution', 'rawOutput', 'hostName', 'hostAlias', 'all']}}, 'includeRawOutput': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability rawOutput in result (default false) '}, 'includeConclusion': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability conclusion in result (default false) '}, 'includeSolution': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability solution in result (default false) '}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending). ', 'items': {'type': 'str', 'enum': ['vulnerabilityID', 'socket', 'name', 'cvss', 'severity', 'resolution', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'resolutionTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded. '}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria). '}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers. ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'minimumCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to vulnerabilities with CVSS score at least this high. ', 'minimum': 0, 'maximum': 10}, 'maximumCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to vulnerabilities with CVSS score no more than this. ', 'minimum': 0, 'maximum': 10}, 'severity': {'type': 'list', 'position': 0, 'description': 'Restrict search to specified severity levels. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['INFO', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'info', 'low', 'medium', 'high', 'critical']}}, 'resolutionCode': {'type': 'list', 'position': 0, 'description': 'Restrict search to specific resolution codes. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['UNRESOLVED', 'ACCEPTED', 'TEMPORARILY_ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE']}}, 'vulnerabilityReference': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability reference. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'vulnerabilityID': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability ID. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'resolutionTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['vulnerabilityID', 'references', 'name', 'description', 'conclusion', 'solution', 'rawOutput', 'hostName', 'hostAlias', 'all']}}, 'includeRawOutput': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability rawOutput in result (default false) '}, 'includeConclusion': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability conclusion in result (default false) '}, 'includeSolution': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability solution in result (default false) '}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending). ', 'items': {'type': 'str', 'enum': ['vulnerabilityID', 'socket', 'name', 'cvss', 'severity', 'resolution', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'resolutionTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded. '}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria). '}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers. ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'minimumCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to vulnerabilities with CVSS score at least this high. ', 'minimum': 0, 'maximum': 10}, 'maximumCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to vulnerabilities with CVSS score no more than this. ', 'minimum': 0, 'maximum': 10}, 'severity': {'type': 'list', 'position': 0, 'description': 'Restrict search to specified severity levels. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['INFO', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'info', 'low', 'medium', 'high', 'critical']}}, 'resolutionCode': {'type': 'list', 'position': 0, 'description': 'Restrict search to specific resolution codes. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['UNRESOLVED', 'ACCEPTED', 'TEMPORARILY_ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE']}}, 'vulnerabilityReference': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability reference. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'vulnerabilityID': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability ID. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'resolutionTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['vulnerabilityID', 'references', 'name', 'description', 'conclusion', 'solution', 'rawOutput', 'hostName', 'hostAlias', 'all']}}, 'includeRawOutput': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability rawOutput in result (default false) '}, 'includeConclusion': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability conclusion in result (default false) '}, 'includeSolution': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability solution in result (default false) '}, 'groupBy': {'type': 'list', 'position': 0, 'description': 'Specify which fields will be grouped by in stats ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['customer', 'host', 'service', 'businessProcess', 'severity', 'vulnerabilityID', 'protocol', 'port', 'reference', 'resolutionCode']}}, 'values': {'type': 'list', 'position': 0, 'description': 'Specify which values will be included in stats (default vulnerabilities) ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['vulnerabilities', 'scannedVulnerabilities', 'resolvedVulnerabilities', 'missedVulnerabilities', 'cvss']}, 'maxItems': 2147483647, 'minItems': 1}, 'resolution': {'type': 'int', 'position': 0, 'description': 'Stats resolution period in milliseconds, if is 0 means to generate non-timeline statistics ', 'minimum': 0}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Reduce stats keys to the cutoff amount of keys that has largest hit count, default 0 means no reduce ', 'minimum': 0}, 'cutoffValue': {'type': 'str', 'position': 0, 'description': 'Specify which value to be cutoff on (default vulnerabilities) ', 'enum': ['vulnerabilities', 'scannedVulnerabilities', 'resolvedVulnerabilities', 'missedVulnerabilities', 'cvss']}, 'includeOthers': {'type': 'bool', 'position': 0, 'description': 'If reduce (cutoff >0), true means remaining keys (other than cutoff keys) are collected into an "other" key, default false '}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending). ', 'items': {'type': 'str', 'enum': ['vulnerabilityID', 'socket', 'name', 'cvss', 'severity', 'resolution', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'resolutionTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'statsID': {'type': 'int', 'position': 0, 'description': 'Statistics ID '}, 'customerID': {'type': 'int', 'position': 0, 'description': 'Customer ID '}, 'resolution': {'type': 'int', 'position': 0, 'description': 'Statistics time frame period length '}, 'resolutionUnit': {'type': 'str', 'position': 0, 'description': 'Time unit for the resolution ', 'enum': ['milliseconds', 'seconds', 'minutes', 'hours', 'days', 'weeks', 'months', 'years']}, 'records': {'type': 'int', 'position': 0, 'description': 'Amount of records '}, 'hitCount': {'type': 'dict', 'position': 0, 'description': 'Total amount of hits per value ', 'additionalProperties': {'type': 'int'}}, 'keyNames': {'type': 'list', 'position': 0, 'description': 'List of key names ', 'items': {'type': 'string'}}, 'valueNames': {'type': 'list', 'position': 0, 'description': 'List of value names ', 'items': {'type': 'string'}}, 'keys': {'type': 'list', 'position': 0, 'description': 'List of statistics keys e.g. {"id":1, "key1Name":"key1", "key2Name":"key2"} ', 'items': {'type': 'dict', 'additionalProperties': {'type': 'object'}}}, 'timeFrames': {'type': 'list', 'position': 0, 'description': 'List of statistics records grouped by time frame ', 'items': {'type': 'dict', 'properties': {'records': {'type': 'list', 'items': {'type': 'dict', 'properties': {'keyID': {'type': 'int'}, 'value': {'type': 'dict', 'additionalProperties': {'type': 'int'}}}}}, 'timeFrame': {'type': 'dict', 'properties': {'startTime': {'type': 'int'}, 'endTime': {'type': 'int'}}}}}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}
update_asset_vulnerability = {'tags': ['assets/v1'], 'summary': 'Updates an existing AssetVulnerability. (PUBLIC)', 'description': '', 'operationId': 'updateAssetVulnerability', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'AssetVulnerability ID', 'required': True, 'type': 'str'}, {'in': 'body', 'name': 'body', 'description': 'AssetVulnerability update request', 'required': False, 'schema': {'type': 'object', 'required': ['source'], 'properties': {'addReferences': {'type': 'list', 'position': 0, 'description': 'Add references to vulnerability (e.g. CVE number). ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'deleteReferences': {'type': 'list', 'position': 0, 'description': 'Delete references from vulnerability. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'str', 'position': 0, 'description': 'Change vulnerability name. Will be sanitized and no line break allowed. ', 'minLength': 0, 'maxLength': 255}, 'description': {'type': 'str', 'position': 0, 'description': 'Change vulnerability description. Will be sanitized. '}, 'conclusion': {'type': 'str', 'position': 0, 'description': 'Change vulnerability summary. Will be sanitized. '}, 'solution': {'type': 'str', 'position': 0, 'description': 'Change vulnerability solution. Will be sanitized. '}, 'rawOutput': {'type': 'str', 'position': 0, 'description': 'Change raw output from vulnerability scan. Will be sanitized. '}, 'cvss': {'type': 'float', 'position': 0, 'description': 'Change CVSS score of vulnerability (range from 0 to 10). ', 'minimum': 0, 'maximum': 10}, 'severity': {'type': 'str', 'position': 0, 'description': 'Change severity level of vulnerability. ', 'enum': ['INFO', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'info', 'low', 'medium', 'high', 'critical']}, 'addProperties': {'type': 'dict', 'position': 0, 'description': 'Add custom properties (updates a property if key already exists).  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}, 'deleteProperties': {'type': 'list', 'position': 0, 'description': 'Delete custom properties by key. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'exploitAvailable': {'type': 'bool', 'position': 0, 'description': 'Set if an exploit is available for the vulnerability. '}, 'source': {'type': 'str', 'position': 0, 'description': 'Source of the request. (default USER)', 'enum': ['USER', 'CVM']}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}}}, '220': {'description': 'No value to be updated', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': {'type': 'string', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'integer', 'format': 'int64'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'object', 'required': ['name'], 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'array', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'number', 'format': 'double'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64'}, 'createdByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64'}, 'lastUpdatedByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64'}, 'deletedByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'firstSeenTimestamp': {'type': 'integer', 'format': 'int64'}, 'lastSeenTimestamp': {'type': 'integer', 'format': 'int64'}, 'resolutionTimestamp': {'type': 'integer', 'format': 'int64'}, 'resolvedByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'string', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'object', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'string', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'string', 'readOnly': True}, 'flags': {'type': 'array', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'string', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}