"""Autogenerated API schema"""
from argus_api import session


impersonate = {'tags': ['authentication/v1'], 'summary': 'Request an impersonated session (INTERNAL)', 'description': 'This operation will spawn a new user session impersonating another user, where the active users permissions are constrained to the intersection of the impersonating and impersonated users, and limited to the subset optionally specified in the request. In addition to returning the impersonating session token, the new session will be set as cookies, overwriting any existing session cookies.', 'operationId': 'impersonate', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Impersonation request', 'required': False, 'schema': {'type': 'object', 'required': ['userName'], 'properties': {'userName': {'type': 'str', 'position': 0, 'description': 'Username of user to impersonate. '}, 'domain': {'type': 'str', 'position': 0, 'description': 'Domain of user to impersonate (id or name) '}, 'customer': {'type': 'list', 'position': 0, 'description': 'Set of customers the session should be valid for. If not specified, customers will be inherited from active permissions. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'function': {'type': 'list', 'position': 0, 'description': 'Set of functions/roles (by name) the session should be granted (default is all current functions). Cannot extend the current set of functions. ', 'uniqueItems': True, 'items': {'type': 'string'}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'forwardedIP': {'type': 'string'}, 'clientIP': {'type': 'string'}, 'uri': {'type': 'string'}, 'requestCredentialsType': {'type': 'str', 'enum': ['sessionToken', 'signature', 'apikey']}, 'requestCredentialsData': {'type': 'string'}}}}}}}}
#: "constrain_1" is an alias for "impersonate"
constrain_1 = impersonate